/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Sałaciński   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qstring.h>
#include "kxgenerator.h"
#include "ServerLayoutWidget.h"
#include "MouseWidget.h"
#include "GlobalFunctions.h"
#include "KeyboardWidget.h"
#include "VideocardWidget.h"
#include "MonitorWidget.h"
#include "AdvancedWidget.h"
#include "Xorg.h"
#include "properties.h"

#define ERR "ERROR"

QString kXGeneratorMain :: Locale (int n)
{
if (n == 0) { return "Server Layout"; }
if (n == 1) { return "Pointer"; }
if (n == 2) { return "Keyboard"; }
if (n == 3) { return "Video Card"; }
if (n == 4) { return "Display"; }
if (n == 5) { return "Advanced Settings"; }
if (n == 6) { return "Accept"; }
if (n == 7) { return "Quit"; }
if (n == 8) { return "Do you really want to quit? Settings will NOT be saved!"; }
if (n == 9) { return "Quit?"; }
if (n == 10) { return "About..."; }

if (n == 500) { return "kX Generator"; }
return ERR;
}

QString ServerLayoutWidget :: Locale (int n)
{
if (n == 0) { return "Server Layout"; }
if (n == 1) { return "&Change entries..."; }
if (n == 2) { return "Advanced"; }
if (n == 3) { return "Pointers"; }
if (n == 4) { return "Keyboards"; }
if (n == 5) { return "Screens"; }
if (n == 6) { return "Add..."; }
if (n == 7) { return "Remove"; }
if (n == 8) { return "Rename"; }
if (n == 9) { return "Here you can modify all pointer devices that will be connected when X start with current Server Layout. Check \"Core pointer\" checkbox if you want pointer to emit core events."; }
if (n == 10) { return "Core Pointer"; }
if (n == 11) { return "Here you can modify all keyboard devices that will be connected when X start with current Server Layout. Check \"Core pointer\" checkbox if you want pointer to emit core events."; }
if (n == 12) { return "Here you can modify screens connected to server."; }
if (n == 13) { return "This pointer is already on the list."; }
if (n == 14) { return "There should be at least one pointer entry."; }
if (n == 15) { return "This keyboard is already on the list."; }
if (n == 16) { return "There should be at least one keyboard entry."; }
if (n == 17) { return "This screen is already on the list."; }
if (n == 18) { return "There should be at least one screen entry."; }

if (n == 500) { return "Error"; }

return ERR;
}

QString MouseWidget :: Locale (int n)
{
if (n == 0) { return "Pointer"; }
if (n == 1) { return "&Change entries..."; }
if (n == 2) { return "Advanced"; }
if (n == 3) { return "Driver:"; }
if (n == 4) { return "Device:"; }
if (n == 5) { return "Driver description"; }
if (n == 6) { return "Autodetect"; }
if (n == 7) { return "Cannot find required input driver %1 on system. Please select another driver."; }
if (n == 8) { return "Error!"; }

return ERR;
}

QString GlobalFunctions :: Locale (int n)
{
if (n == 0) { return "Add pointer"; }
if (n == 1) { return "Please select pointer device you wish to add from the list:"; }

if (n == 200) { return "Mouse"; }

if (n == 300) { return "NVidia Accelerated Graphics Driver"; }

if (n == 1000) { return "No description yet!"; }
return ERR;
}

QString KeyboardWidget :: Locale(int n)
{
if (n == 0) { return "Keyboard"; }
if (n == 1) { return "&Change entries..."; }
if (n == 2) { return "Driver:"; }
if (n == 3) { return "Layout:"; }
if (n == 4) { return "Model:"; }
if (n == 5) { return "Device:"; }
if (n == 6) { return "Protocol:"; }
if (n == 7) { return "Auto Repeat:"; }
if (n == 8) { return "Delay before repeating (ms):"; }
if (n == 9) { return "Repeat rate:"; }
if (n == 10) { return "Autodetect"; }




if (n == 999) { return "Not specified"; }
if (n == 1000) { return "af - Afrikaans"; }
if (n == 1001) { return "ar - Arabic"; }
if (n == 1002) { return "bg - Bulgarian"; }
if (n == 1003) { return "bo - Tibetan"; }
if (n == 1004) { return "br - Breton"; }
if (n == 1005) { return "ca - Catalan"; }
if (n == 1006) { return "cs - Czech"; }
if (n == 1007) { return "cy - Welsh"; }
if (n == 1008) { return "da - Danish"; }
if (n == 1009) { return "de - German"; }
if (n == 1010) { return "el - Greek"; }
if (n == 1011) { return "en_GB - English (Great Britain)"; }
if (n == 1012) { return "en_US - English (United States)"; }
if (n == 1013) { return "eo - Esperanto"; }
if (n == 1014) { return "es - Spanish"; }
if (n == 1015) { return "et - Estonian"; }
if (n == 1016) { return "eu - Basque"; }
if (n == 1017) { return "fi - Finnish"; }
if (n == 1018) { return "fr - French"; }
if (n == 1019) { return "ga - Irish"; }
if (n == 1020) { return "gl - Galician"; }
if (n == 1021) { return "gu - Gujarati"; }
if (n == 1022) { return "he - Hebrew"; }
if (n == 1023) { return "hi - Hindi"; }
if (n == 1024) { return "hu - Hungarian"; }
if (n == 1025) { return "id - Indonesian"; }
if (n == 1026) { return "is - Icelandic"; }
if (n == 1027) { return "it - Italian"; }
if (n == 1028) { return "ja - Japanese"; }
if (n == 1029) { return "km - Cambodian"; }
if (n == 1030) { return "ko - Korean"; }
if (n == 1031) { return "lt - Lithuanian"; }
if (n == 1032) { return "lv - Latvian (Lettish)"; }
if (n == 1033) { return "mi - Maori"; }
if (n == 1034) { return "mk - Macedonian"; }
if (n == 1035) { return "mr - Marathi"; }
if (n == 1036) { return "nl - Dutch"; }
if (n == 1037) { return "no - Norwegian"; }
if (n == 1038) { return "oc - Occitan"; }
if (n == 1039) { return "pl - Polish"; }
if (n == 1040) { return "pt - Portuguese"; }
if (n == 1041) { return "ro - Romanian"; }
if (n == 1042) { return "ru - Russian"; }
if (n == 1043) { return "sk - Slovak"; }
if (n == 1044) { return "sl - Slovenian"; }
if (n == 1045) { return "sr - Serbian"; }
if (n == 1046) { return "sv - Swedish"; }
if (n == 1047) { return "ta - Tamil"; }
if (n == 1048) { return "th - Thai"; }
if (n == 1049) { return "tr - Turkish"; }
if (n == 1050) { return "uk - Ukrainian"; }

if (n == 2000) { return "Not specified"; }
if (n == 2001) { return "PC-105"; }              //pc105
if (n == 2002) { return "PC-104"; }              //pc104
if (n == 2003) { return "Logicordless"; }        //logicordless
if (n == 2004) { return "Macintosh"; }           //macintosh
if (n == 2005) { return "PC-98"; }               //pc98
if (n == 2006) { return "Solaris 8 on x86"; }    //pc101_sol8x86

if (n == 2010) { return "Standard"; }            //Standard
if (n == 2011) { return "Xqueue"; }              //Xqueue




return ERR;
}

QString Xorg :: Locale(int n)
{
if (n == 0) { 
QString ToRet = QString("# X Server Configuration file generated by ").append(APPNAME).append(" ").append(APPVERSION).append("\n");
ToRet = ToRet.append("# (c) ").append(APPYEAR).append(" ").append(APPAUTHOR).append("\n");


return ToRet;
}
return ERR;
}

QString VideocardWidget :: Locale(int n)
{
if (n == 0) { return "Video Card"; }
if (n == 1) { return "Change entries..."; }
if (n == 2) { return "Advanced"; }
if (n == 3) { return "Driver:"; }
if (n == 4) { return "Vendor name:"; }
if (n == 5) { return "Driver information"; }

return ERR;
}

QString MonitorWidget :: Locale(int n)
{
if (n == 0) { return "Display"; }
if (n == 1) { return "Here you can modify display properties - display modes, refresh rates, monitor information."; }
if (n == 2) { return "Monitor"; }
if (n == 3) { return "Screen"; }
if (n == 4) { return "Monitor:"; }
if (n == 5) { return "Change entries..."; }
if (n == 6) { return "Vendor:"; }
if (n == 7) { return "Model:"; }
if (n == 8) { return "Monitor is DPMS compilant"; }
if (n == 9) { return "Monitor:"; }
if (n == 10) { return "Video card:"; }
if (n == 11) { return "Screen:"; }
if (n == 12) { return "Screen modes..."; }

return ERR;
}

QString AdvancedWidget :: Locale(int n)
{
if (n == 0) { return "Advanced settings TODO"; }
if (n == 1) { return "In this section you can modify advanced X properties - file paths, modules and extensions."; }
return ERR;
}

